import { Component, OnInit, Input, Type, ViewContainerRef, ComponentFactoryResolver, ComponentRef, ViewChild, HostBinding, HostListener, AnimationTransitionEvent, ChangeDetectionStrategy, OnDestroy } from '@angular/core';
import { trigger, transition, style, animate, state } from '@angular/animations';
import { Router, NavigationStart } from '@angular/router';
import { Subscription } from 'rxjs/Subscription';
import { InputType, OverlayFunction } from '../service/modal.service';
import 'rxjs/add/operator/filter';
var ModalComponent = /** @class */ (function () {
    function ModalComponent(resolver, router) {
        this.resolver = resolver;
        this.router = router;
    }
    ModalComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (!!this.width) {
            this.hostWidth = this.width;
        }
        if (!!this.height) {
            this.hostHeight = this.height;
        }
        var factory = this.resolver.resolveComponentFactory(this.injectComponent.component);
        this.componentRef = this.viewContainerRef.createComponent(factory);
        if (!!this.injectComponent.inputs) {
            Object.keys(this.injectComponent.inputs)
                .forEach(function (key) { return _this.componentRef.instance[key] = _this.injectComponent.inputs[key]; });
        }
        this.componentRef.instance.modal = this;
        this.scaling = true;
        this.subscription = this.router.events
            .filter(function (p) { return p instanceof NavigationStart; })
            .subscribe(function () {
            _this.componentRef.destroy();
            _this.injectComponent.reject();
        });
        if (this.showOverlay) {
            this.showOverlay();
        }
    };
    ModalComponent.prototype.ngOnDestroy = function () {
        if (this.hideOverlay) {
            this.hideOverlay();
        }
        this.subscription.unsubscribe();
    };
    ModalComponent.prototype.close = function (result) {
        this.result = result;
        this.scaling = false;
    };
    ModalComponent.prototype.animationDone = function (e) {
        if (!e.toState) {
            this.injectComponent.resolve(this.result);
            this.componentRef.destroy();
        }
    };
    return ModalComponent;
}());
export { ModalComponent };
//# sourceMappingURL=modal.component.js.map