import { Injectable, ComponentFactoryResolver, Type, ViewContainerRef, ComponentRef, ApplicationRef } from '@angular/core';
import { ModalComponent } from './../modal/modal.component';
var ModalService = /** @class */ (function () {
    function ModalService(resolver, applicationRef) {
        this.resolver = resolver;
        this.applicationRef = applicationRef;
    }
    Object.defineProperty(ModalService.prototype, "viewContainerRef", {
        get: function () {
            var appInstance = this.applicationRef.components[0].instance;
            if (!appInstance.viewContainerRef) {
                var appName = this.applicationRef.componentTypes[0].name;
                throw new Error("Missing 'viewContainerRef' declaration in " + appName + " constructor");
            }
            return appInstance.viewContainerRef;
        },
        enumerable: true,
        configurable: true
    });
    ModalService.prototype.open = function (component, inputs, width, height) {
        var _this = this;
        var componentRef;
        return new Promise(function (mainResolve, mainReject) {
            new Promise(function (resolve, reject) {
                setTimeout(function () {
                    var factory = _this.resolver.resolveComponentFactory(ModalComponent);
                    componentRef = _this.viewContainerRef.createComponent(factory);
                    componentRef.instance['injectComponent'] = {
                        component: component, inputs: inputs, resolve: resolve, reject: reject
                    };
                    componentRef.instance.width = width;
                    componentRef.instance.height = height;
                    componentRef.instance.showOverlay = _this.showOverlay;
                    componentRef.instance.hideOverlay = _this.hideOverlay;
                }, 0);
            }).then(function (result) {
                componentRef.destroy();
                mainResolve(result);
            }).catch(function (reason) {
                componentRef.destroy();
                mainReject(reason);
            });
        });
    };
    ModalService.prototype.setOverlay = function (showOverlay, hideOverlay) {
        this.showOverlay = showOverlay;
        this.hideOverlay = hideOverlay;
    };
    return ModalService;
}());
export { ModalService };
//# sourceMappingURL=modal.service.js.map